SU(1)

NOME
su - cambia ID utente o diventa amministratore

SINOSSI

su [opzioni] [-] [nome [ args ]]

DESCRIZIONE

The su command is used to become another user during a login session. Invoked without a username, su defaults to becoming the superuser. The - option may be used to provide an environment similar to what the user would expect had the user logged in directly. The -c option may be used to treat the next argument as a command by most shells.

Options are recognized everywhere in the argument list. You can use the -- argument to stop option parsing. The - option is special: it is also recognized after --, but has to be placed before username.

All'utente viene quindi chiesta la password, se necessario. Una password errata viene segnalata da un messaggio d'errore. Viene effettuato il log di tutti i tentativi, siano essi riusciti o meno, al fine di rilevare ogni abuso del sistema.

The current environment is passed to the new shell. The value of $PATH is reset to /bin:/usr/bin for normal users, or /sbin:/bin:/usr/sbin:/usr/bin for the superuser. This may be changed with the ENV_PATH and ENV_SUPATH definitions in /etc/login.defs.

Un sottosistema di login è indicato dalla presenza del carattere «*» all'inizio della shell di login. La directory home impostata sarà utilizzata come root di un nuovo file system al quale l'utente accede.

OPZIONI

The options which apply to the su command are:

-c, --command COMMAND
    Specify a command that will be invoked by the shell using its -c.

    The executed command will have no controlling terminal. This option cannot be used to execute interactive programs which need a controlling TTY.

-, -l, --login
    Fornisce un ambiente simile a quello che un utente si attende quando effettua direttamente il login.

    When - is used, it must be specified before any username. For portability it is recommended to use it as last option, before any username. The other forms (-l and --login) do not have this restriction.

-s, --shell SHELL
    La shell che verrà invocata.

    The invoked shell is chosen from (highest priority first):

        The shell specified with --shell.

        If --preserve-environment is used, the shell specified by the $SHELL environment variable.

        The shell indicated in the /etc/passwd entry for the target user.

        /bin/sh if a shell could not be found by any above method.

    If the target user has a restricted shell (i.e. the shell field of this user's entry in /etc/passwd is not listed in /etc/shells), then the --shell option or the $SHELL environment variable won't be taken into account, unless su is called by root.

-m, -p, --preserve-environment
    Preserve the current environment, except for:

    $PATH
        reset according to the /etc/login.defs options ENV_PATH or ENV_SUPATH (see below);

    $IFS
        reset to «<space><tab><newline>», if it was set.

    If the target user has a restricted shell, this option has no effect (unless su is called by root).

    Note that the default behavior for the environment is the following:

        The $HOME, $SHELL, $USER, $LOGNAME, $PATH, and $IFS environment variables are reset.

        If --login is not used, the environment is copied, except for the variables above.

        If --login is used, the $TERM, $COLORTERM, $DISPLAY, and $XAUTHORITY environment variables are copied if they were set.

        If --login is used, the $TZ, $HZ, and $MAIL environment variables are set according to the /etc/login.defs options ENV_TZ, ENV_HZ, MAIL_DIR, and MAIL_FILE (see below).

        If --login is used, other environment variables might be set by the ENVIRON_FILE file (see below).

AVVISI/CAVEAT

This version of su has many compilation options, only some of which may be in use at any particular site.

CONFIGURAZIONE

The following configuration variables in /etc/login.defs change the behavior of this tool:

CONSOLE (string)
    Se definito, o il percorso completo di un file che contiene l'elenco di nomi di device (uno per riga) oppure un elenco di nomi di device separati da «:». L'accesso come root verrà permesso solo attraverso questi device.

    Se non definito, root potrà accedere da qualsiasi device.

    Il nome di device deve essere specificato senza il prefisso /dev.

CONSOLE_GROUPS (string)
    List of groups to add to the user's supplementary groups set when logging in on the console (as determined by the CONSOLE setting). Default is none.

    Use with caution - it is possible for users to gain permanent access to these groups, even when not logged in on the console.

DEFAULT_HOME (boolean)
    Indica se permettere l'accesso al sistema anche se non si può accedere alla directory home. Il valore predefinito è no.

    If set to yes, the user will login in the root (/) directory if it is not possible to cd to her home directory.

ENV_HZ (string)
    If set, it will be used to define the HZ environment variable when a user login. The value must be preceded by HZ=. A common value on Linux is HZ=100.

ENVIRON_FILE (string)
    Se questo file esiste ed è leggibile, l'ambiente di login viene letto da lì. Ogni riga deve essere nella forma nome=valore.

    Le righe che iniziano con «#» sono trattate come commenti e ignorate.

ENV_PATH (string)
    If set, it will be used to define the PATH environment variable when a regular user login. The value is a colon separated list of paths (for example /bin:/usr/bin) and can be preceded by PATH=. The default value is PATH=/bin:/usr/bin.

ENV_SUPATH (string)
    If set, it will be used to define the PATH environment variable when the superuser login. The value is a colon separated list of paths (for example /sbin:/bin:/usr/sbin:/usr/bin) and can be preceded by PATH=. The default value is PATH=/sbin:/bin:/usr/sbin:/usr/bin.

ENV_TZ (string)
    If set, it will be used to define the TZ environment variable when a user login. The value can be the name of a timezone preceded by TZ= (for example TZ=CST6CDT), or the full path to the file containing the timezone specification (for example /etc/tzname).

    If a full path is specified but the file does not exist or cannot be read, the default is to use TZ=CST6CDT.

LOGIN_STRING (string)
    Il testo da utilizzare per richiedere la password. Il valore predefinito è «Password: » o una sua traduzione. Se si imposta questa variabile allora il testo non verrà tradotto.

    If the string contains %s, this will be replaced by the user's name.

MAIL_CHECK_ENAB (boolean)
    Abilita la verifica e stampa a video dello stato della casella di posta al momento dell'accesso al sistema.

    Andrebbe disabilitato se i file di avvio della shell effettuano già questo controllo («mailx -e» o equivalente).

MAIL_DIR (string)
    La directory di spool per la posta. Questa è necessaria per manipolare la casella di posta quando il corrispondente account utente viene modificato o cancellato. Se non è specificata viene utilizzato un valore impostato al momento della compilazione.

MAIL_FILE (string)
    Imposta la posizione delle caselle di posta degli utenti relative alla loro directory home.

The MAIL_DIR and MAIL_FILE variables are used by useradd, usermod, and userdel to create, move, or delete the user's mail spool.

If MAIL_CHECK_ENAB is set to yes, they are also used to define the MAIL environment variable.

QUOTAS_ENAB (boolean)
    Enable setting of resource limits from /etc/limits and ulimit, umask, and niceness from the user's passwd gecos field.

SULOG_FILE (string)
    Se definito, tutta l'attività di «su» viene tracciata in questo file.

SU_NAME (string)
    Se definito è il nome del comando da mostrare quando si esegue «su -». Ad esempio, se lo di definisce come «su» allora «ps» mostrerà che il comando è «-su». Se non definito, «ps» mostrerà il nome della shell invocata, come «-sh».

SU_WHEEL_ONLY (boolean)
    If yes, the user must be listed as a member of the first gid 0 group in /etc/group (called root on most Linux systems) to be able to su to uid 0 accounts. If the group doesn't exist or is empty, no one will be able to su to uid 0.

SYSLOG_SU_ENAB (boolean)
    Enable "syslog" logging of su activity - in addition to sulog file logging.

USERGROUPS_ENAB (boolean)
    Abilita l'impostazione dei bit di gruppo di umask in modo che siano gli stessi dei bit del proprietario (esempio: 022 -> 002, 077 -> 007) per utenti non root a condizione che uid e gid siano identici e che il nome utente sia lo stesso del gruppo primario.

    If set to yes, userdel will remove the user's group if it contains no more members, and useradd will create by default a group with the name of the user.

FILE

/etc/passwd
    Informazioni sugli account utente.

/etc/shadow
    Informazioni sicure sugli account utente.

/etc/login.defs
    Configurazione del pacchetto password shadow

VALORI RESTITUITI

On success, su returns the exit value of the command it executed.

If this command was terminated by a signal, su returns the number of this signal plus 128.

If su has to kill the command (because it was asked to terminate, and the command did not terminate in time), su returns 255.

Some exit values from su are independent from the executed command:

0
    success (--help only)

1
    System or authentication failure

126
    The requested command was not found

127
    The requested command could not be executed

VEDERE ANCHE

login(1), login.defs(5), sg(1), sh(1).